<?php
// Show First Post plugin
// By Jasiu
// Fixed for 1.4.x by krig
// Fixed for 1.8.x by rockenren
if (!defined("IN_MYBB")) {
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

if (!function_exists('q')) {
	function q($str) {
		return "#" . preg_quote($str) . "#";
	}
}
$plugins->add_hook("showthread_start", "show_first_post_init_lang");
$plugins->add_hook("showthread_linear", "show_first_post");
$plugins->add_hook("moderation_start", "moderation_hook");
$plugins->add_hook("moderation_stick", "moderation_stick");

function show_first_post_info() {
	return array(
		"name"			=> "Show First Post",
		"description"	=> "Shows first post of the thread in second and next pages",
		"website"		=> "",
		"author"		=> "Jasiu, krig, rockenren",
		"authorsite"	=> "http://www.mybb.cal.pl",
		"version"		=> "1.5",
		"guid" 			=> "",
		"compatibility" => "18*",
	);
}

function show_first_post_activate() {
	require_once MYBB_ROOT . '/inc/adminfunctions_templates.php';
	global $db;

	$setting_group = array (
		"gid" => "NULL",
		"name" => "first_post_mod_settings",
		"title" => "First Post Mod Settings",
		"description" => "Settings for the First Post Mod.",
		"disporder" => "4",
		"isdefault" => "no",

	);
	$db->query("DELETE FROM " . TABLE_PREFIX . "settinggroups WHERE name='first_post_mod_settings'");
	$db->insert_query("settinggroups", $setting_group);
	$gid = $db->insert_id();

	$setting_1 = array (
		"sid" => "NULL",
		"name" => "auto_pin_forums",
		"title" => "Auto Pin First Post",
		"description" => "Auto Pin First Post In Forums(Example:1,72,12)",
		"optionscode" => "text",
		"value" => "",
		"disporder" => "2",
		"gid" => intval($gid),
	);
	$setting_2 = array (
		"sid" => "NULL",
		"name" => "auto_pin_all_forums",
		"title" => "Auto Pin First Post In All Forums",
		"description" => "",
		"optionscode" => "onoff",
		"value" => "",
		"disporder" => "1",
		"gid" => intval($gid),
	);

	$db->query("DELETE FROM " . TABLE_PREFIX . "settings WHERE name IN('auto_pin_forums')");
	$db->insert_query("settings", $setting_1);
	$db->insert_query("settings", $setting_2);

	$fp_template = array (
		"title" => 'global_first_post',
		"template" => '<table border="0" cellspacing="{$theme['.'borderwidth'.']}" cellpadding="{$theme['.'tablespace'.']}" class="tborder tfixed clear">
				<tr>
				<td class="thead">
				<div><strong>{$lang->first_post} — {$thread['.'threadprefix'.']}{$thread['.'subject'.']}</strong></div>
				</td>
				</tr>
				<tr>
				<td id="posts_container">
				<div id="posts">
				{$posts}
				</div>
				</td>
				</tr>
				</table>
				<br />',
		"sid" => -1,
		"version" => 122,
		"status" => '',
		"dateline" => time(),);
	$db->insert_query('templates', $fp_template);
	find_replace_templatesets("showthread", '#{\$header}(\r?)\n#', "{\$header}\n{\$fpost2}\n");
	find_replace_templatesets("showthread_moderationoptions_stickunstick", q('<option value="stick">{$lang->stick_unstick_thread}</option>'), '<option value="stick">{$lang->stick_unstick_thread}</option><option value="fix">{$lang->fix_first_post}</option>');

	$query = $db->query("DESCRIBE " . TABLE_PREFIX . "threads 'fix_first_post'");
	if ($db->num_rows($query) == 0) {
		$db->query("ALTER  TABLE " . TABLE_PREFIX . "threads ADD  `fix_first_post` TINYINT( 1 ) UNSIGNED DEFAULT '0' NOT NULL");
	}
}
function show_first_post_deactivate() {
	require_once MYBB_ROOT . '/inc/adminfunctions_templates.php';
	global $db;

	$db->query("DELETE FROM " . TABLE_PREFIX . "templates WHERE title='global_first_post'");
	find_replace_templatesets("showthread", '#{\$fpost2}(\r?)\n#', "", 0);
	find_replace_templatesets("showthread_moderationoptions_stickunstick", q('<option value="fix">{$lang->fix_first_post}</option>'), "", 0);
	$db->query("DELETE FROM " . TABLE_PREFIX . "settinggroups WHERE name='first_post_mod_settings'");
	$db->query("DELETE FROM " . TABLE_PREFIX . "settings WHERE name IN('auto_pin_forums', 'auto_pin_all_forums')");
}
function do_show_first_post() {
	global $db, $mybb, $templates, $fpost2, $firstpostcontent, $thread, $lang,$settings,$attachcache;
	$forums=explode(",",$settings['auto_pin_forums']);
	if (!function_exists('build_postbit')) {
		require_once MYBB_ROOT . '/inc/functions_post.php';
	}
	if ($thread['fix_first_post'] > 0 || $settings['auto_pin_all_forums'] || array_search($thread['fid'],$forums)!==false) {
		$pfirst = true;
		$posts = '';
		$sql="SELECT u.*, u.username " .
		"AS userusername, p.*, f.*, eu.username AS editusername" .
		" FROM " . TABLE_PREFIX . "posts p" .
		" LEFT JOIN " . TABLE_PREFIX . "users u ON ( u.uid = p.uid ) " .
		" LEFT JOIN " . TABLE_PREFIX . "userfields f ON( f.ufid = u.uid ) " .
		" LEFT JOIN " . TABLE_PREFIX . "users eu ON( eu.uid = p.edituid ) " .
		" WHERE p.tid = '" . $thread['tid'] . "' " .
		" ORDER BY p.dateline ASC LIMIT 0, 1 ";
		$query = $db->query($sql);
		while ($post = $db->fetch_array($query)) {
			$query = $db->simple_select("attachments", "*", "pid=".$post['pid']);
			while($attachment = $db->fetch_array($query))
			{
				$attachcache[$attachment['pid']][$attachment['aid']] = $attachment;
			}
			$post['visible'] = 1;
			$posts .= build_postbit($post);
			$post = '';
			$pfirst = false;
		}
		eval (" \$fpost2 = \"" . $templates->get("global_first_post") . " \";");
	}
}
function show_first_post_init_lang() {
	global $lang;
	$lang->load("first_post");
}
function show_first_post() {
	global $start, $fpost2;
	if ($start == 0) {
		$fpost2 = "";
	} else {
		do_show_first_post();
	}
}
function moderation_hook() {
	global $fixFirstPost, $mybb;
	if ($mybb->input['action'] == "fix") {
		$mybb->input['action'] = 'stick';
		$fixFirstPost = true;
	} else {
		$fixFirstPost = false;
	}
}
function moderation_stick() {
	global $fixFirstPost, $tid, $thread, $db;
	if ($fixFirstPost) {
		$fix = array (
			"fix_first_post" => $thread['fix_first_post'] ? 0 : 1,
		);
		$db->update_query("threads", $fix, "tid=$tid");
		redirect("showthread.php?tid=$tid", "");
	}
}
?>
